/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// kickaction.h Fri Jun 15 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _KICKACTION_H_
#define _KICKACTION_H_

#include "action.h"

class KickAction : public Action
{
public: 
	KickAction();
	KickAction(const Angle &_aDirection, double _dIntensity);
	virtual ~KickAction();
	virtual Action* copy() const;
	virtual ServerCommand* translate() const;	
	
	void setDirection(const Angle &_aDirection);
	void setIntensity(double dIntensity);
	
	Angle getDirection() const;
	double getIntensity() const;
	
    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;
	
private:
	Angle aDirection;
	double dIntensity;
	static bool fTriedBackKick;
};

#endif
