/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// turncommand.h Fri Jun 22 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _TURNCOMMAND_H_
#define _TURNCOMMAND_H_

#include "servercommand.h"
#include "angle.h"

class TurnCommand : public ServerCommand
{
public: 
	TurnCommand();
	TurnCommand(double _dMomentRad);
	virtual ~TurnCommand();
	virtual Comm& comm_insert(Comm &_cmConnection) const;
	
	void setTurnMoment(double _dMomentRad);
	double getTurnMoment() const;

	virtual bool isTurn () { return true; }
private:
	double dMomentRad;
};

#endif
