/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// audioworldperception.cpp Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "audioworldperception.h"

AudioWorldPerception::AudioWorldPerception(const WorldModel& _wmWorld) : Perception(_wmWorld)
{
}

AudioWorldPerception::~AudioWorldPerception()
{
}

bool AudioWorldPerception::myTurn() const
{
    int iNumber = wmWorld.getClientPlayer().getNumber();

    if((wmWorld.getTime() % MAX_PLAYER) == iNumber) return true;

    return false;
}



bool AudioWorldPerception::fillMsg(AudioMsg& _pamMsg)
{
//    TRACE("Preparing audio message at time: " << wmWorld.getTime());

    if(wmWorld.getWorldBall().getAge() <= 1)
        _pamMsg.addBall(wmWorld.getWorldBall());


/*
    for(int i = 1; i <= MAX_PLAYER; ++i) {
        WorldPlayer wpPlayer;

        wpPlayer = wmWorld.getOtherPlayer(i);
        if( (wpPlayer.isKnown())
             && (wpPlayer.getAge() <= 1)
          ) _pamMsg.addPlayer(wpPlayer);

        wpPlayer = wmWorld.getOurPlayer(i);
        if( (wpPlayer.isKnown())
             && (wpPlayer.getAge() <= 1)
          ) _pamMsg.addPlayer(wpPlayer);
    }
*/

    return true;
}

bool AudioWorldPerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_PLAY_ON) ||
        (pmTemp == PLAY_MODE_DROP_BALL)
      ) return true;

    return false;
}
