/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// backlineperception.h Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef BACKLINEPERCEPTION_H
#define BACKLINEPERCEPTION_H

#include "perception.h"

/**
  *@author UVa RoboCup Team
  */

class BackLinePerception : public Perception  {
public: 
	BackLinePerception(const WorldModel &_wmWorld);
	virtual ~BackLinePerception();

	bool isBehindBall ();
	Vector2d getBallAbsPos();

	bool slowRun() const;
	double distToBallX () const;
	Angle getBodyDir();
	int getBallAge() const;
	bool isActiveMode() const;



};

#endif
