/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// behindballperception.h Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef BEHINDBALLPERCEPTION_H
#define BEHINDBALLPERCEPTION_H

#include "perception.h"
#include "types.h"
#include "constants.h"

/**
  *@author UVa RoboCup Team
  */

class BehindBallPerception : public Perception  {
public: 
	BehindBallPerception(const WorldModel &_wmWorld);
	virtual ~BehindBallPerception();

	Vector2d getBallAbsPos();
	bool inAttackingThird(WorldObject _woObj);
	bool inMiddleThird(WorldObject _woObj);
	bool inDefensiveThird(WorldObject _woObj);
	bool inOurPenaltyArea(WorldObject _woObj);
	WorldBall getBall();
	bool isWellBehindBall ();
	Angle getBodyDir();
	double distToLine () const;
	int xDistIndex() const;
	int getBallAge() const;

	bool isActiveMode() const;
	bool slowRun() const;
	bool lowStamina() const;
	bool ballTooDeep() const;
	bool inGoalBox(Vector2d v) const;
};

#endif
