/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// clearballbehavior.cpp Thu Jul 19 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "clearballbehavior.h"
#include "kickaction.h"

ClearBallBehavior::ClearBallBehavior(const WorldModel& _wmWorld) : perClearBall(_wmWorld)
{
}

ClearBallBehavior::~ClearBallBehavior()
{
}

bool ClearBallBehavior::isUseful()
{
  if (!perClearBall.ballTooOld() && perClearBall.atBall() && perClearBall.onDefense())
    {
      return true;
    }
  
  return false;
}

void ClearBallBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recClearBall;
  KickAction kaKick;

  /*! give up a corner! */
  // kaKick.setDirection (perClearBall.relPos (FLAGPOS (FLAG_LEFT_BOTTOM_20)).getAngle ());

  kaKick.setDirection (perClearBall.angleToKick());  
  kaKick.setIntensity(100);
  
  recClearBall.addAction(kaKick);
  
  // Add a second kick for good measure...
  //! recClearBall.addAction(kaKick);

  recClearBall.setGrade(95);
  
  // for debugging only
  recClearBall.szBehaviorName = "clearball";
  recList.insert(recClearBall); 
}
