/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// cornerkickbehavior.cpp Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "cornerkickbehavior.h"
#include "kickaction.h"
#include "turnaction.h"
#include "runaction.h"

CornerKickBehavior::CornerKickBehavior(const WorldModel& _wmWorld) : perCornerKick(_wmWorld)
{
}

CornerKickBehavior::~CornerKickBehavior()
{
}

bool CornerKickBehavior::isUseful()
{
  if (!perCornerKick.isActiveMode ())
    {
      gotThere = false;
    }
  
  if (perCornerKick.amIClosestToBall (1)
      && perCornerKick.isActiveMode ()
      && !perCornerKick.inPosition ())
    {
      if (!gotThere)
	{
	  gotThere = true;
	  return true;
	}
      else
	{
	  return false;
	}
    }

  return false;
}

void CornerKickBehavior::evaluate(RecommendationList &recList)
{
  Recommendation recCornerKick;
  recCornerKick.szBehaviorName = "cornerkick";
  
  RunAction raRun;
  
  raRun.setDirection(perCornerKick.getRunAngle());
  
  if(perCornerKick.getStamina() > 3000) 
    raRun.setIntensity(45);
  else
    raRun.setIntensity(0);	  
  
  recCornerKick.addAction(raRun);
  recCornerKick.addAction(raRun);
  recCornerKick.addAction(raRun);
  
  recCornerKick.setGrade(100);
  recList.insert(recCornerKick);
}
