/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// coverperception.h Thu Jul 26 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef COVERPERCEPTION_H
#define COVERPERCEPTION_H

#include "perception.h"

/**
  *@author UVa RoboCup Team
  */

class CoverPerception : public Perception  {
public: 
	CoverPerception(const WorldModel &_wmWorld);
	virtual ~CoverPerception();
	

	WorldPlayer* getCoverPlayer() const;
	bool inDefensiveThird(WorldObject _woObj) const;
	bool isSmallestTeamDist(const WorldObject& _woObj, double _dDist) const;
	Angle getBodyDir() const;
	bool onGoalSide(const WorldObject& _woObj);
	WorldBall getBall();
	bool tooFarUp () const;
	bool isActiveMode() const;

};

#endif
