/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gotogoalbehavior.cpp Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "gotogoalbehavior.h"
#include "dribbleaction.h"
#include "turnaction.h"
#include "changeviewaction.h"

GoToGoalBehavior::GoToGoalBehavior(const WorldModel &_wmWorld) : perGoToGoal(_wmWorld)
{
	iUsefulCount = 0;
}

GoToGoalBehavior::~GoToGoalBehavior()
{
}

bool GoToGoalBehavior::isUseful()
{
	//if (!fAlreadyKicked && perGoToGoal.atBall() && !perGoToGoal.ballMovingFaster())
	//if (!perGoToGoal.ballTooOld() && ((perGoToGoal.atBall() || perGoToGoal.willPassBall()) || (fAlreadyKicked && perGoToGoal.ballAged())))
	
	//if (!perGoToGoal.ballTooOld() && (perGoToGoal.atBall()  || (fAlreadyKicked && perGoToGoal.ballAged())))
	if (!perGoToGoal.ballTooOld() && perGoToGoal.atBall()  && perGoToGoal.isBreakAway())
	{
		return true;
		//if (iUseful == 3) iUseful = 0; else iUseful++;
	}
	
	fAlreadyKicked = false;
	
	return false;
}

void GoToGoalBehavior::evaluate(RecommendationList& recList)
{
	Recommendation recGoToGoal;
    recGoToGoal.szBehaviorName = "gotogoal";	
	
  // TODO: perhaps turning to the ball after you kick should be in a separate behavior?
/*	if (fAlreadyKicked)
	{
		TurnAction taTurnToBall(aLastKickDir);
		recGoToGoal.addAction(taTurnToBall);
		recGoToGoal.setGrade(90);
		
		fAlreadyKicked = false;
		recList.insert(recGoToGoal);
		return;
	}
*/
	Angle aDribbleAngle = perGoToGoal.angleToKick();
	aLastKickDir = aDribbleAngle;
	
	DribbleAction daDribble(aDribbleAngle);
  	recGoToGoal.addAction(daDribble);
  		
	if(!perGoToGoal.correctViewMode(VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH))
    {
    	ChangeViewAction cvaNewView(VIEW_WIDTH_WIDE, VIEW_QUALITY_HIGH);		
   		recGoToGoal.addAction(cvaNewView);
    }

	recGoToGoal.setGrade(90);
	
	fAlreadyKicked = true;
	
    recList.insert(recGoToGoal);
}
