/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// gotogoalbehavior.h Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _GOTOGOALBEHAVIOR_H_
#define _GOTOGOALBEHAVIOR_H_

#include "behavior.h"
#include "gotogoalperception.h"

class GoToGoalBehavior : public Behavior
{
public: 
	GoToGoalBehavior(const WorldModel &_wmWorld);
	virtual ~GoToGoalBehavior();
 	virtual bool isUseful();
	virtual void evaluate(RecommendationList& recList);

private:
	GoToGoalPerception perGoToGoal;
	bool fAlreadyKicked;
	int iUsefulCount;
	Angle aLastKickDir;
};

#endif
