/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// offensecenterbehavior.cpp Fri Aug 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "offensecenterbehavior.h"

OffenseCenterBehavior::OffenseCenterBehavior(const WorldModel &_wmWorld): perOffCenter(_wmWorld)
{
}

OffenseCenterBehavior::~OffenseCenterBehavior()
{
}

bool OffenseCenterBehavior::isUseful()
{
  if (perOffCenter.isActiveMode() 
      && (perOffCenter.getPossession() != PS_THEIRS)
      && perOffCenter.amInOffense())
    {
      return true;
    }

  return false;
}

void OffenseCenterBehavior::evaluate(RecommendationList &recList)
{
  TRACE("OffenseCenterBehavior::evaluate() got called!");
  Recommendation recFinal;
  recFinal.szBehaviorName = "offensecenter";
  
  
  if (!perOffCenter.amClose())
    {
      RunAction raRun;
      raRun.setDirection( perOffCenter.relPos(Vector2d(0.5 * FIELD_LENGTH - PENALTY_AREA_LENGTH, 0.0)).getAngle() );//getRunAngle() );
      raRun.setIntensity(80);
      recFinal.addAction(raRun);	
      recFinal.addAction(raRun);	
      recFinal.setGrade(80);
    }
  else
    {
      RunAction raRun;
      raRun.setDirection(0);
      raRun.setIntensity(0);
      recFinal.addAction(raRun);	
      recFinal.setGrade(10);
    }
  

  recList.insert(recFinal);
}
