//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members
// of the Mainz Rolling Brains RoboCup Team
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-///////////////////////////////////////////////////////////
//
//   $Id: recommendation.cpp,v 1.20 2001/08/01 15:51:52 jmm9gc Exp $
//   $Manager: eri$
//
//   recommendation.C
//   cwz-build-command: make recomendation
////////////////////////////////////////////////////////////////////////

#include "recommendation.h"
#include "action.h"

using namespace std;

Recommendation::Recommendation()
{
    szBehaviorName = "UNKNOWNRECOMMENDATION"; // logging
}

Recommendation::Recommendation(const Recommendation& rhs)
{
    if(this == &rhs) return;

    gGrade = rhs.getGrade();
    szBehaviorName = rhs.szBehaviorName;
    alActions = rhs.alActions; // this was a tough one
}

Recommendation::~Recommendation()
{

}

void Recommendation::setGrade(const Grade &_gGrade)
{
	gGrade = _gGrade;
}

Grade Recommendation::getGrade() const
{
	return gGrade;
}

/*
void Recommendation::addAction(Action* _pacAction)
{
	TRACE("addAction: " << *_pacAction);
	alActions.push_back(_pacAction);
}
*/

void Recommendation::addAction(const Action& _acAction)
{
	alActions.insert(_acAction);
}
void Recommendation::setActionList(const ActionList &_alActions)
{
	alActions = _alActions;
}

const ActionList& Recommendation::getActionList() const
{
	return alActions;
}

string Recommendation::getBehaviorName() const
{
	return szBehaviorName;
}

/*
ActionList Recommendation::combine(const ActionList &_alActions) const
{
	ActionList alNew = alActions.merge(_alActions);

	return alNew;
}
*/

bool Recommendation::operator==(const Recommendation& rec) const
{
	return (getGrade() == rec.getGrade());
}

bool Recommendation::operator>(const Recommendation& rec) const
{
	return (getGrade() > rec.getGrade());
}

bool Recommendation::operator<(const Recommendation& rec) const
{
	return (getGrade() < rec.getGrade());
}

bool Recommendation::operator>=(const Recommendation& rec) const
{
	return (getGrade() >= rec.getGrade());
}

bool Recommendation::operator<=(const Recommendation& rec) const
{
	return (getGrade() <= rec.getGrade());
}

Recommendation& Recommendation::operator=(const Recommendation &rec)
{
	if (&rec == this)
		return *this;
		
	gGrade = rec.getGrade();
	alActions = rec.getActionList();
	szBehaviorName = rec.getBehaviorName();
	
	return *this;
}

Recommendation* Recommendation::copy() const
{
    return new Recommendation(*this);
}

ostream& Recommendation::ostream_insert(ostream& _out) const
{
    _out << szBehaviorName << ": grade=" << getGrade().getValue() << "." << endl;
    //<< alActions;

    return _out;
}

ofstream& Recommendation::ofstream_insert(ofstream& _fout) const
{

    _fout << "<recommendation source=\"" << szBehaviorName
          << "\" grade=\"" << getGrade().getValue() << "\">" << endl;


    _fout << alActions;


    _fout << "</recommendation>" << endl;
    return _fout;
}

ostream& operator<<(ostream& _out, const Recommendation& _rec)
{
    _rec.ostream_insert(_out);
    return _out;
}

ofstream& operator<<(ofstream& _fout, const Recommendation& _rec)
{
    _rec.ofstream_insert(_fout);
    return _fout;
}
